﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using Microsoft.Practices.Composite.Events;

namespace infraGridBug
{
    public class Window1ViewModel : IWindow1ViewModel,INotifyPropertyChanged
    {
 
        private SomeData dta { get; set; }
        private IEventAggregator _eventAggregator;
        private ObservableCollection<SomeData> _someDatas { get; set; }
        public ObservableCollection<SomeData> SomeDatas 
        { get 
        { return _someDatas;} 
          set
          {
              _someDatas = value;
              OnPropertyChanged("SomeDatas");
          }
        }
        private ObservableCollection<ComboBoxData> _comboDatas { get; set; }
        public ObservableCollection<ComboBoxData> ComboBoxDatas
        {
            get
            { return _comboDatas; }
            set
            {
                _comboDatas = value;
                OnPropertyChanged("ComboBoxDatas");
            }
        }

        public Window1ViewModel()
        {
           // _eventAggregator = eventAggregator;
            SomeDatas = GetSomeDatas();
            ComboBoxDatas = GetComboDatas();
        }


        private ObservableCollection<ComboBoxData> GetComboDatas()
        {
            var odtas = new ObservableCollection<ComboBoxData>();
            ComboBoxData odta;
            for (int i = 0; i < 100; i++)
            {

                odta = new ComboBoxData()
                           {
                               ComboboxInt = i % 3,
                               ComboboxDesc = "tst" + (i %3)
                           };
                if(odtas.Where(x=>x.ComboboxDesc == odta.ComboboxDesc).Count() == 0)
                odtas.Add(odta);
            }

            return odtas;
        }

        private ObservableCollection<SomeData> GetSomeDatas()
        {
            var odtas = new List<ComboBoxData>();
            var dtas = new ObservableCollection<SomeData>();
            for (int i = 0; i < 100; i++)
            {


                dta = new SomeData
                          {
                              SomeData1 = i % 3,
                              SomeData2 = "desc" + i,
                              SomeData3 = i % 3,
                              SomeData4 = "PPD" + i,
                              SomeData5 = (double)i + .1,
                              SomeData6 = (double)i + .1,
                              SomeData7 = (double)i + .1,
                              SomeData8 = (double)i + .1,
                              SomeData9 = (double)i + .1,
                              SomeData10 = (double)i + .1,
                              SomeData11 = (double)i + .1,
                              SomeData12 = (double)i + .1,
                              SomeData13 = (double)i + .1,
                              SomeData14 = (double)i + .1
                          };
                dtas.Add(dta);
            }
            return dtas;
 

        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;

            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion
    }
    public class ComboBoxData
    {
        public int ComboboxInt { get; set; }
        public string ComboboxDesc { get; set; }
    }

    public class SomeData
    {
        public int SomeData1 { get; set; }
        public string SomeData2 { get; set; }
        public int SomeData3 { get; set; }
        public string SomeData4 { get; set; }
        public double SomeData5 { get; set; }
        public double SomeData6 { get; set; }
        public double SomeData7 { get; set; }
        public double SomeData8 { get; set; }
        public double SomeData9 { get; set; }
        public double SomeData10 { get; set; }
        public double SomeData11 { get; set; }
        public double SomeData12 { get; set; }
        public double SomeData13 { get; set; }
        public double SomeData14 { get; set; }

    }
}
